{
Fetches all Fields, MySQL-table has, Uses mysql
Different from FetchField by using "MysqlFetchFields"!

1. Init a Handle to Mysql (MysqlInit)
2. Connect to Mysql (MysqlRealConnect)
3. Create a database (MysqlCreateDb)
4. Select this database as the one to use (MysqlSelectDb)
5. Create a table (MysqlQuery)
6. List all fields from this table (down from MysqlListFields)
7. Clean up (Drop the Database and so on)

}

program fetchfields;

uses MySQL;

var 
	MHandle: PMySQL;
	MRes   : PMySQLRes;
	NumFields : Cardinal;
	i      : Integer;
	Fields : MySQLFieldArray;
	
begin	MHandle:=MySQLInit (MHandle);
  if MySQLRealConnect (MHandle, 'localhost', '', '', '', 0, nil, 0) =nil then
    WriteLn  (' Error: MySQLRealConnect returned nil ')
  else
    begin
      Write ('Create Database ''test_MySQLunit''..');
      if not MySQLCreateDb (MHandle, 'test_MySQLunit') then
        begin
          MySQLClose (MHandle);
          WriteLn ('failed!!!  (Maybe extists or you don''t have the permission)');
          Halt (1)
        end;
      WriteLn ('done.');
      Write ('Select Db to ''test_MySQLunit''..');
      if not MySQLSelectDb (MHandle, 'test_MySQLunit') then
        begin
          MySQLClose (MHandle);
          WriteLn ('failed!!!');
          Halt (1)
        end;	
      WriteLn ('done.');
      Write ('Create Table ''MySQLtest''..');
      if not MySQLQuery (MHandle, 
        'CREATE TABLE MySQLtest (nr INT, firstname VARCHAR (100), lastname VARCHAR (100))') then
        begin
          WriteLn ('failed!!!');
          if not MySQLDropDb (MHandle, 'test_MySQLunit') then
            WriteLn ('Please Clean up mynually');
          MySQLClose (MHandle);
          Halt (1)
        end;
      WriteLn ('done.');
      MRes := MySQLListFields (MHandle, 'MySQLtest', nil);
      if MRes = nil then
        WriteLn  ('Error: table `MySQLtest'' not found.')
      else
        begin
          NumFields := MySQLNumFields (MRes);
          WriteLn ('Debug: ', NumFields);
          Fields := MySQLFetchFields (MRes);
          WriteLn ('Debug: ', NumFields);
          for i := 0 to NumFields - 1 do
            begin
              if CString2String (Fields[i].name) = '' then
                WriteLn ('err');
              WriteLn (i, ') ', CString2String (Fields[i].name))
            end;
          
          {Free the Mem }
          MySQLFreeResult (MRes)
        end;
      Write ('Clean up..');
      { Clean up }
      if not MySQLDropDb (MHandle, 'test_MySQLunit') then
        WriteLn ('Can''t Drop Database! Please clean up manually')
      else
        WriteLn ('done.');
      MySQLClose (MHandle)
    end
end.
